#!/bin/sh
###############################################################################
#                      FULL BACKUP UYILITY FOR Dreambox                       #
#                       Building image WITH Japhar SSL                        #
#                     Japhar Team http://www.japhar.com/                      #
###############################################################################
#

rm /home/root/.ash_history
rm /hdd/*.nfo
rm /hdd/swapfile_backup
rm /hdd/secondstage.bin

if [ -z "$1" ]
then
      echo "NOK : Folder name is empty we set it up to /media/hdd"
      DIRECTORY="/media/hdd"
else
      echo "OK : Folder name specified, "$DIRECTORY
      DIRECTORY=$1
fi

init 4

MOUNTPOINT=/tmp
DATE=`date +%Y-%m-%d@%H.%M.%S`
MKFS=mkfs.jffs2
UBIFS=mkfs.ubifs
UBINIZE=ubinize
SUMTOOL=sumtool
BUILDIMAGE=buildimage
Nanddump=nanddump
SND=secondstage-$BOXTYPE.bin
IMAGEINFO="Backup"
BACKUPIMAGE=$DIRECTORY/$IMAGEINFO-$DATE-SSL-$VSND.nfi

if [ -e /dev/mtdblock2 ]; then
	MTDBOOT=/dev/mtdblock2
	MTDROOT=/dev/mtdblock3
elif [ -e /dev/mtdblock/2 ]; then
	MTDBOOT=/dev/mtdblock/2
	MTDROOT=/dev/mtdblock/3
else
	echo "No mtdblocks found"
	exit 1
fi

if [ -e /dev/mtd/1 ]; then
   $Nanddump --noecc --omitoob --bb=skipbad --truncate --file /dev/null /dev/mtd/1 > /tmp/.raedtmp 2>&1
else
   $Nanddump --noecc --omitoob --bb=skipbad --truncate --file /dev/null /dev/mtd1 > /tmp/.raedtmp 2>&1
fi

RAEDTMP=/tmp/.raedtmp 2> /dev/null
HEADER=`head -n 1 $RAEDTMP`
BLOCKSIZE=`echo $HEADER | cut -d"," -f 2 | cut -d" " -f 4`

OPTIONS=" -e 0x4000 -n -l"
UBIOPTIONS="-m 512 -e 15KiB -c 3735 -F"
UBINIZE_OPTIONS="-m 512 -p 16KiB -s 512"
UBINIZECFG="/tmp/ubinize.cfg"
UBICOMPRESSION="zlib"
if grep -qs dm500hd /proc/stb/info/model ; then
   BOXTYPE=dm500hd
   BUILDOPTIONS=" --brcmnand -a dm500hd -e 0x4000 -f 0x4000000 -s 512 -b 0x40000:$DIRECTORY/secondstage.bin -d 0x3C0000:$DIRECTORY/boot.img -d 0x3C00000:$DIRECTORY/root.img"
fi
if grep -qs dm500hdv2 /proc/stb/info/model ; then
   BOXTYPE=dm500hdv2
   BUILDOPTIONS="-a dm500hdv2 --brcmnand -e 0x20000 -f 0x10000000 -s 2048 -b 0x100000:$DIRECTORY/secondstage.bin -d 0x700000:$DIRECTORY/boot.img -d 0xF800000:$DIRECTORY/root.img"
   UBIBUILDOPTIONS="-a dm500hdv2 --brcmnand -e 0x20000 -f 0x10000000 -s 2048 -b 0x100000:$DIRECTORY/secondstage.bin -d 0x700000:$DIRECTORY/boot.img -d 0x3F800000:$DIRECTORY/root.img"
   OPTIONS=" -e 0x20000 -n -l"
   UBIOPTIONS="-m 2048 -e 124KiB -c 3320 -F"
   UBINIZE_OPTIONS="-m 2048 -p 128KiB -s 2048"
   UBINIZE_VOLSIZE="402MiB"
   UBINIZE_DATAVOLSIZE="569MiB"
   UBICOMPRESSION="favor_lzo"
   CACHED="-c"
fi
if grep -qs dm800 /proc/stb/info/model ; then
   BOXTYPE=dm800
   BUILDOPTIONS=" --brcmnand -a dm800 -e 0x4000 -f 0x4000000 -s 512 -b 0x40000:$DIRECTORY/secondstage.bin -d 0x3C0000:$DIRECTORY/boot.img -d 0x3C00000:$DIRECTORY/root.img"
fi
if grep -qs dm800se /proc/stb/info/model ; then
   BOXTYPE=dm800se
   BUILDOPTIONS=" --brcmnand -a dm800se -e 0x4000 -f 0x4000000 -s 512 -b 0x40000:$DIRECTORY/secondstage.bin -d 0x3C0000:$DIRECTORY/boot.img -d 0x3C00000:$DIRECTORY/root.img"
fi
if grep -qs dm800sev2 /proc/stb/info/model ; then
   BOXTYPE=dm800sev2
   BUILDOPTIONS="-a dm800sev2 --brcmnand -e 0x20000 -f 0x10000000 -s 2048 -b 0x100000:$DIRECTORY/secondstage.bin -d 0x700000:$DIRECTORY/boot.img -d 0xF800000:$DIRECTORY/root.img"
   UBIBUILDOPTIONS="-a dm800sev2 --brcmnand -e 0x20000 -f 0x10000000 -s 2048 -b 0x100000:$DIRECTORY/secondstage.bin -d 0x700000:$DIRECTORY/boot.img -d 0x3F800000:$DIRECTORY/root.img"
   OPTIONS=" -e 0x20000 -n -l"
   UBIOPTIONS="-m 2048 -e 124KiB -c 3320 -F"
   UBINIZE_OPTIONS="-m 2048 -p 128KiB -s 2048"
   UBINIZE_VOLSIZE="402MiB"
   UBINIZE_DATAVOLSIZE="569MiB"
   UBICOMPRESSION="favor_lzo"
   CACHED="-c"
fi
if grep -qs dm8000 /proc/stb/info/model ; then
   BOXTYPE=dm8000
   BUILDOPTIONS="-a dm8000 -e 0x20000 -f 0x10000000 -s 2048 -b 0x100000:$DIRECTORY/secondstage.bin -d 0x700000:$DIRECTORY/boot.img -d 0xF800000:$DIRECTORY/root.img"
   OPTIONS=" -e 0x20000 -n -l"
   UBIOPTIONS="-m 2048 -e 126KiB -c 1961 -F"
   UBINIZE_OPTIONS="-m 2048 -p 128KiB -s 512"
   UBICOMPRESSION="favor_lzo"
fi
if [ -e /proc/stb/info/vumodel -o -e /proc/stb/info/boxtype ]; then
   BOXTYPE=guest
   UBIOPTIONS="-m 2048 -e 124KiB -c 4096 -F"
   UBINIZE_OPTIONS="-m 2048 -p 128KiB"
   CACHED="-c"
fi
UBIBUILDOPTIONS=$BUILDOPTIONS
if grep -qs dm7020hd /proc/stb/info/model ; then
   BOXTYPE=dm7020hd
   if [ $BLOCKSIZE -eq 4096 ]; then
      BUILDOPTIONS="-a dm7020hd --brcmnand -e 0x40000 -f 0x10000000 -s 4096 -b 0x100000:$DIRECTORY/secondstage.bin -d 0x700000:$DIRECTORY/boot.img -d 0xF800000:$DIRECTORY/root.img"
      UBIBUILDOPTIONS="-a dm7020hd --brcmnand -e 0x40000 -f 0x10000000 -s 4096 -b 0x100000:$DIRECTORY/secondstage.bin -d 0x700000:$DIRECTORY/boot.img -d 0x3F800000:$DIRECTORY/root.img"
      OPTIONS=" -e 0x40000 -n -l"
      UBIOPTIONS="-m 4096 -e 248KiB -c 1640 -F"
      UBINIZE_OPTIONS="-m 4096 -p 256KiB -s 4096"
      UBINIZE_VOLSIZE="397MiB"
      UBINIZE_DATAVOLSIZE="574MiB"
   else
      BUILDOPTIONS="-a dm7020hd --brcmnand -e 0x20000 -f 0x10000000 -s 2048 -b 0x100000:$DIRECTORY/secondstage.bin -d 0x700000:$DIRECTORY/boot.img -d 0xF800000:$DIRECTORY/root.img"
      UBIBUILDOPTIONS="-a dm7020hd --brcmnand -e 0x20000 -f 0x10000000 -s 2048 -b 0x100000:$DIRECTORY/secondstage.bin -d 0x700000:$DIRECTORY/boot.img -d 0x3F800000:$DIRECTORY/root.img"
      OPTIONS=" -e 0x20000 -n -l"
      UBIOPTIONS="-m 2048 -e 124KiB -c 3320 -F"
      UBINIZE_OPTIONS="-m 2048 -p 128KiB -s 2048"
      UBINIZE_VOLSIZE="402MiB"
      UBINIZE_DATAVOLSIZE="569MiB"
   fi
   UBICOMPRESSION="favor_lzo"
   CACHED="-c"
fi

if [ BOXTYPE ] ; then
	VSND=$BOXTYPE
else
	echo "Box not found !!!"
	exit 0
fi

echo
echo "***********************"
echo "* "$BOXTYPE "FOUND *"
echo "***********************"
echo

echo "---------------------------------------------------------------"

rm "$DIRECTORY"/swapfile_backup

case "$DIRECTORY" in
	/media/net* )
		echo "Skipping SWAP-creation because the backup will be done to a network device"
	;;
	* )
echo "Creating swapfile on $DIRECTORY with "128"MB"
if [ -s "$DIRECTORY"/swapfile_backup ] ; then
		echo "----------------------------------------"
		echo "Found swapfile"
		echo "----------------------------------------"
  else
  dd if=/dev/zero of=$DIRECTORY/swapfile_backup bs=1024k count=128 >> $RAEDTMP 2>&1
  mkswap $DIRECTORY/swapfile_backup
  swapon $DIRECTORY/swapfile_backup
echo "---------------------------------------------------------------"
  echo "Swapfile activated"
echo "---------------------------------------------------------------"
fi
	;;
esac

echo "***********************************************"
starttime="$(date +%s)"
echo "* Started BackUp at: `date +%H:%M:%S`          *"
echo "***********************************************"

umount $MOUNTPOINT/bi/boot  2> /dev/null
umount $MOUNTPOINT/bi/root  2> /dev/null

rm -rf $MOUNTPOINT/bi/boot  2> /dev/null
rm -rf $DIRECTORY/boot.img > /dev/null 2>&1
rm -rf $DIRECTORY/boot.ubi > /dev/null 2>&1
rm -rf $DIRECTORY/root.img > /dev/null 2>&1
rm -rf $DIRECTORY/root.ubi > /dev/null 2>&1

mkdir -p $MOUNTPOINT/bi/root > /dev/null 2>&1
mkdir -p $MOUNTPOINT/bi/boot > /dev/null 2>&1

if grep -qs dm800sev2 /proc/stb/info/model ; then
cp /boot/* $MOUNTPOINT/bi/boot; cd $MOUNTPOINT/bi/boot; ln -sfn vmlinux-3.2-dm800sev2.gz vmlinux
ln -sfn /usr/share/bootlogo.mvi bootlogo.mvi; ln -sfn bootlog.mvi backdrop.mvi; ln -sfn bootlogo.mvi bootlogo_wait.mvi; cd /
sed -ie s!"root=/dev/mtdblock3 rootfstype=jffs2"!"ubi.mtd=root root=ubi0:rootfs rootfstype=ubifs"!g $MOUNTPOINT/bi/boot/autoexec*.bat
sed -ie s!"console=null"!"console=ttyS0,115200"!g $MOUNTPOINT/bi/boot/autoexec*.bat
sed -ie s!"quiet"!""!g $MOUNTPOINT/bi/boot/autoexec*.bat
else
mount -t jffs2 $MTDBOOT $MOUNTPOINT/bi/boot
fi

echo "Grabbing from Flash the secondstage built-in the image"
if [ ! -f $SND ] ; then
if [ -e /dev/mtd/1 ]; then
$Nanddump --noecc --omitoob --bb=skipbad --truncate --file $DIRECTORY/secondstage.bin /dev/mtd/1 > /dev/null 2>&1 
else
$Nanddump --noecc --omitoob --bb=skipbad --truncate --file $DIRECTORY/secondstage.bin /dev/mtd1 > /dev/null 2>&1
fi
fi

             ./mkfs.jffs2 --root=$MOUNTPOINT/bi/boot --faketime --output=$DIRECTORY/boot.img $OPTIONS
             UBI=0
             dd if=/dev/mtdblock3 of=$RAEDTMP bs=3 count=1 > /dev/null 2>&1
             if [ `grep UBI $RAEDTMP | wc -l` -gt 0 ]; then
             echo  "UBIFS Filesystem ..." 
			 UBI=1
             echo \[root\] > $UBINIZECFG
             echo mode=ubi >> $UBINIZECFG
             echo image=$DIRECTORY/root.ubi >> $UBINIZECFG
             echo vol_id=0 >> $UBINIZECFG
             echo vol_name=rootfs >> $UBINIZECFG
             echo vol_type=dynamic >> $UBINIZECFG
             if [ $BOXTYPE != "dm7020hd" ]; then   
             echo vol_flags=autoresize >> $UBINIZECFG
             else 
             echo vol_size=$UBINIZE_VOLSIZE >> $UBINIZECFG
             echo \[data\] >> $UBINIZECFG
             echo mode=ubi >> $UBINIZECFG
             echo vol_id=1 >> $UBINIZECFG
             echo vol_type=dynamic >> $UBINIZECFG
             echo vol_name=data >> $UBINIZECFG
             echo vol_size=$UBINIZE_DATAVOLSIZE >> $UBINIZECFG
             echo vol_flags=autoresize >> $UBINIZECFG
             fi
             else
             echo  "jffs2 Filesystem ..." 
             fi
			 mkdir -p $MOUNTPOINT/bi/root 2> /dev/null
             if [ $UBI -eq 1 ]; then
			   echo "Relax 5 or 6 minutes until finishing"
			   echo "---------------------"
               mount -t ubifs /dev/ubi0_0 $MOUNTPOINT/bi/root > /dev/null 2>&1
               ./mkfs.ubifs $UBIOPTIONS -x $UBICOMPRESSION -r $MOUNTPOINT/bi/root -o $DIRECTORY/root.ubi 
               ./ubinize -o $DIRECTORY/root.img $UBINIZE_OPTIONS $UBINIZECFG 
             else
			   echo "Relax 5 or 6 minutes until finishing"
			   mount -o bind / $MOUNTPOINT/bi/root > /dev/null 2>&1
			   if [ -e $MOUNTPOINT/bi/root/dev/usbdev1.1_ep00 ] ; then
                  echo "Removing /dev/usbdev* (they will be back again after reboot)"
                  rm -rf $MOUNTPOINT/bi/root/dev/usbdev* > /dev/null 2>&1
               fi
               ./mkfs.jffs2 --root=$MOUNTPOINT/bi/root --faketime --output=$DIRECTORY/root.img $OPTIONS 
             fi
               echo "---------------------"
			 echo "create Secondstageloader..."
			 if [ -s $DIRECTORY/secondstage.bin ] ; then
             if [ $BOXTYPE == "dm7020hd" -o $BOXTYPE == "dm8000" ]; then
             if [ $UBI -eq 0 ]; then
                 sumtool --input=/hdd/boot.img --output=$DIRECTORY/boots.img $OPTIONS 
                 cp $DIRECTORY/boots.img $DIRECTORY/boot.img 
                 rm $DIRECTORY/boots.img 
                 sumtool --input=/hdd/root.img --output=$DIRECTORY/roots.img $OPTIONS
                 cp $DIRECTORY/roots.img $DIRECTORY/root.img 
                 rm $DIRECTORY/roots.img 
              fi
			  fi
              if [ $UBI -eq 1 ]; then
                 ./buildimage $UBIBUILDOPTIONS > $BACKUPIMAGE
                 else
                 ./buildimage $BUILDOPTIONS > $BACKUPIMAGE
              fi
		SZboot=`ls -al $DIRECTORY/boot.img | awk '{print $5}'`
		SZroot=`ls -al $DIRECTORY/root.img | awk '{print $5}'`
	    SZssl=`ls -al $DIRECTORY/secondstage.bin | awk '{print $5}'`
        SZimage=`ls -al $BACKUPIMAGE | awk '{print $5}'`
        SZsum=`expr $SZboot "+" $SZroot "+" $SZssl`
        SZdiff=`expr $SZimage "-" $SZsum`
		echo "----------------------------------------------------------------------"
		echo "FlashBackup created in:" $BACKUPIMAGE
		echo "----------------------------------------------------------------------"
			echo "Enigma2: Experimental " > $DIRECTORY/$IMAGEINFO-$BOXTYPE-$DATE-SSL-$VSND.nfo
			echo "Machine: Dreambox $BOXTYPE" >> $DIRECTORY/$IMAGEINFO-$BOXTYPE-$DATE-SSL-$VSND.nfo
			echo "Date: "$DATE | cut -d '@' -f1 | sed -e "s/-//g" >> $DIRECTORY/$IMAGEINFO-$BOXTYPE-$DATE-SSL-$VSND.nfo
			echo "Issuer: " >> $DIRECTORY/$IMAGEINFO-$BOXTYPE-$DATE-SSL-$VSND.nfo
			echo $LINK >> $DIRECTORY/$IMAGEINFO-$BOXTYPE-$DATE-SSL-$VSND.nfo
			md5NFO=`md5sum $BACKUPIMAGE | cut -d ' ' -f1`
			echo "MD5: $md5NFO" >> $DIRECTORY/$IMAGEINFO-$BOXTYPE-$DATE-SSL-$VSND.nfo
            umount $MOUNTPOINT/bi/boot  2> /dev/null
	        umount $MOUNTPOINT/bi/root  2> /dev/null
            rm -rf $DIRECTORY/boot.img > /dev/null 2>&1
            rm -rf $DIRECTORY/boot.ubi > /dev/null 2>&1
            rm -rf $DIRECTORY/root.img > /dev/null 2>&1
            rm -rf $DIRECTORY/root.ubi > /dev/null 2>&1
    fi
    stoptime="$(date +%s)"
    elapsed_seconds="$(expr $stoptime - $starttime)"
echo "***********************************************"
echo "* FlashBackup finished at: `date +%H:%M:%S`            *"
echo "* Duration of FlashBackup: $((elapsed_seconds / 60))minutes $((elapsed_seconds % 60))seconds *"
echo "***********************************************"

rm /hdd/*.nfo
rm /hdd/secondstage.bin

init 3

exit 0